	Rem -- global vars
	
    Dim invoice_number
	Dim mode 
	Dim showmypdf
	Dim restartPrinting
	
	restartPrinting = False
		
	Sub OnMacrosApplied
        context("Config")("rememberlastoptionset") = "no"  
		context("Config")("format") = "pdfa3b"
		context("Config")("compatibilitylevel") = "1.7"
		
		Rem -- 7-PDF Printer Process must not lock the pdf, so we disable this feature and use a ShellExecute at the end
		context("Config")("showpdf") = "no"
		Rem -- Important: Let the value be always "no" here!
		
		Rem -- 7-PDF ATTACH EXTRACT AND REMOVE Tool can be called in mode "gui",
		Rem -- "console" and totally "hidden" (default here)!
		mode = "hidden"	
		
		Rem -- SHELLEXECUTE global variable to show the PDF finally ("yes" or "no" ?)
		Rem -- If we will show the 7-PDF ATTACH EXTRACT AND REMOVE Tool GUI, we disable ShowMyPDF!

		If mode = "gui" Then
			showmypdf = "no"
		Else
			Rem -- Note: If you are using our pdf printer as "shared pdf network printer",
			Rem -- You should also set the variable showmypdf fix to "no"
			Rem -- Remember: You surely need that on a printer server environment!
			showmypdf = "yes"
		End If	
				
	End Sub
     	
	Sub OnAfterPrint()
		Dim myOutputFileName
		Dim objShell
		Dim exitCode
		Dim command
		Dim fso
		
		exitCode = -1
		Set fso = CreateObject("Scripting.FilesystemObject")
		
		myOutputFileName = Context("OutputFileName")
		
		' === 7-PDF Attach Extract and Remove ===
				
		Rem -- For Generation you have to install 7-PDF Attach Extract and Remove
		Rem -- DO NOT CHANGE THE DEFAULT INSTALLATION PATH OF THE TOOL! 
		Rem -- If necessary the macro try to install it automatically.
		
		If IsGeneratorInstalled() Then
			If UserAgreesToGeneration() Then
				GenerateEInvoice(myOutputFileName)
			Else
				If AskUserForGenerationConsent() Then
					EnableGenerationConsent()
					GenerateEInvoice(myOutputFileName)
				Else
					MsgBox "E-Invoice generation skipped.", vbInformation, "Generation Skipped"
				End If
			End If
		Else
			If PromptToInstallGenerator() Then
				InstallGenerator()
			End If
		End If
		
		' === 7-PDF Validator ===
		
		Rem -- For Validations you have to install 7-PDF E-Invoice Validator
		Rem -- DO NOT CHANGE THE DEFAULT INSTALLATION PATH OF THE TOOL! 
		Rem -- If necessary the macro try to install it automatically.
		
		If IsValidatorInstalled() Then
			If UserAgreesToValidation() Then
				ValidateEInvoice(myOutputFileName)
			Else
				If AskUserForValidationConsent() Then
					EnableValidationConsent()
					ValidateEInvoice(myOutputFileName)
				Else
					MsgBox "E-Invoice validation skipped.", vbInformation, "Validation Skipped"
				End If
			End If
		Else
			If PromptToInstallValidator() Then
				InstallValidator()
			End If
		End If
		
		If restartPrinting = False Then
			If showmypdf = "yes" Then
				Set objShell = CreateObject("Shell.Application")
				objShell.ShellExecute myOutputFileName, "", "", "open", 1
			End If
		End If
			
	End Sub
	
	' === H E L P E R - F U N C T I O N S ===
	
	' === A T T A C H - T O O L ===
	
	Function AskUserForGenerationConsent()
		AskUserForGenerationConsent = (MsgBox("Would you like to enable generation ZUGFeRD XML via our 7-PDF Invoice Extractor online generation service?" & vbCrLf & "Your invoice data will be processed temporarily on our server in Germany. This can take a moment, please wait...", vbYesNo + vbQuestion, "Enable Generation?") = vbYes)
	End Function
	
	Sub EnableGenerationConsent()
		Dim iniPath, fso, iniFile, lines, line, i, newLines, sectionFound, settingFound
		iniPath = CreateObject("WScript.Shell").ExpandEnvironmentStrings("%APPDATA%") & "\7-PDFAttachExtractAndRemoveFiles\app.ini"

		Set fso = CreateObject("Scripting.FileSystemObject")
		sectionFound = False
		settingFound = False

		If fso.FileExists(iniPath) Then

			Set iniFile = fso.OpenTextFile(iniPath, 1) ' Read mode
			lines = Split(iniFile.ReadAll, vbCrLf)
			iniFile.Close

			newLines = ""

			For i = 0 To UBound(lines)
				line = Trim(lines(i))

				If line = "[7PDF_SETTINGS]" Then
					sectionFound = True
				End If

				If InStr(1, line, "PrivacyPolicyAggreed=", vbTextCompare) > 0 Then
					settingFound = True
					newLines = newLines & "PrivacyPolicyAggreed=YES" & vbCrLf
				Else
					newLines = newLines & line & vbCrLf
				End If
			Next

			If sectionFound And Not settingFound Then
				newLines = newLines & "PrivacyPolicyAggreed=YES" & vbCrLf
			End If

			If Not sectionFound Then
				newLines = newLines & vbCrLf & "[7PDF_SETTINGS]" & vbCrLf & "PrivacyPolicyAggreed=YES" & vbCrLf
			End If

			Set iniFile = fso.OpenTextFile(iniPath, 2) ' Write mode
			iniFile.Write newLines
			iniFile.Close
		Else
			MsgBox "Config file not found: " & iniPath, vbExclamation, "Error"
		End If

		Set iniFile = Nothing
		Set fso = Nothing
	End Sub

	Function IsGeneratorInstalled()
		Dim fso
		Set fso = CreateObject("Scripting.FilesystemObject")
		IsGeneratorInstalled = fso.FileExists("C:\Program Files (x86)\7-PDF\7-PDF Attach Extract And Remove Files\PDFAttachExtractAndRemoveFiles.exe")
		Set fso = Nothing
	End Function
	
	Function UserAgreesToGeneration()
		Dim iniPath, fso, iniFile, line, found
		iniPath = CreateObject("WScript.Shell").ExpandEnvironmentStrings("%APPDATA%") & "\7-PDFAttachExtractAndRemoveFiles\app.ini"

		Set fso = CreateObject("Scripting.FilesystemObject")
		If fso.FileExists(iniPath) Then
			Set iniFile = fso.OpenTextFile(iniPath, 1)
			Do While Not iniFile.AtEndOfStream
				line = Trim(iniFile.ReadLine)
				If InStr(1, line, "PrivacyPolicyAggreed=YES", vbTextCompare) > 0 Then
					found = True
					Exit Do
				End If
			Loop
			iniFile.Close
			Set iniFile = Nothing
		End If
		Set fso = Nothing
		UserAgreesToGeneration = found
	End Function
	
	Sub GenerateEInvoice(ByVal pdfFile)
		Dim objShell, exitCode, command
		
		Set objShell = CreateObject("WScript.Shell")
		command = """C:\Program Files (x86)\7-PDF\7-PDF Attach Extract And Remove Files\PDFAttachExtractAndRemoveFiles.exe"" -mode ""hidden"" -usage ""generate"" -inpdf """ & pdfFile & """"
		exitCode = objShell.Run(command, 0, True)

		Select Case exitCode
			Case 0
				MsgBox "Well done!! The ZUGFeRD PDF was **created** successfully! All done.", vbInformation, "Generation successfull"
			Case 1
				MsgBox "The ZUGFeRD PDF was NOT **created**! Please make sure your monthly subscription limit or your limit of 25 free invoice runs has not been reached. Otherwise, please try again later!", vbCritical, "Generation Failed"
			Case 2
				MsgBox "Please chech that you have a valid license for 7-PDF Attach Extract and Remove! Also be sure your monthly subscription limit or your limit of 25 free invoice runs has not been reached.", vbExclamation, "License Required"
				objShell.Run "https://www.7-pdf.com/products/pdf-attach-extract-and-remove/upgrade-to-full-version", 1, False
		End Select
		Set objShell = Nothing
	End Sub
	
	Function PromptToInstallGenerator()
		PromptToInstallGenerator = (MsgBox("7-PDF Attach Extract and Remove for generating ZUGFeRD XML by using 7-PDF Invoice Extractor service is not installed." & vbCrLf & "Would you like to download and install it now? This can take a moment, please wait...", vbYesNo + vbQuestion, "Generator Missing") = vbYes)
	End Function
	
	Sub InstallGenerator()
		Dim objShell, http, stream, downloadPath, fso, downloadsFolder, installerUrl

		Set objShell = CreateObject("WScript.Shell")
		downloadsFolder = objShell.ExpandEnvironmentStrings("%USERPROFILE%") & "\Downloads"
		downloadPath = downloadsFolder & "\PDFAttachExtractAndRemoveFiles.exe"
		installerUrl = "https://www.7-pdf.de/sites/default/files/downloads/7-pdf-attach-extract-and-remove/PDFAttachExtractAndRemoveFiles.exe"

		Set fso = CreateObject("Scripting.FileSystemObject")
		If Not fso.FolderExists(downloadsFolder) Then
			fso.CreateFolder downloadsFolder
		End If

		Set http = CreateObject("MSXML2.XMLHTTP")
		Set stream = CreateObject("ADODB.Stream")

		http.Open "GET", installerUrl, False
		http.Send

		If http.Status = 200 Then
			stream.Type = 1
			stream.Open
			stream.Write http.ResponseBody
			stream.SaveToFile downloadPath, 2
			stream.Close
			objShell.Run """" & downloadPath & """ /VERYSILENT", 0, True
			MsgBox "Installation completed! Please restart printing.", vbInformation, "Installation Done"
			restartPrinting = True
		Else
			MsgBox "Error downloading installation file. Please try again later.", vbCritical, "Error"
		End If

		Set http = Nothing
		Set stream = Nothing
		Set objShell = Nothing
	End Sub
	
	' === V A L I D A T O R ===
	
	Function AskUserForValidationConsent()
		AskUserForValidationConsent = (MsgBox("Would you like to enable validation via our online validation service?" & vbCrLf & "Your invoice data will be processed temporarily on our server in Germany. This can take a moment, please wait...", vbYesNo + vbQuestion, "Enable Validation?") = vbYes)
	End Function
	
	Sub EnableValidationConsent()
		Dim iniPath, fso, iniFile, lines, line, i, newLines, sectionFound, settingFound
		iniPath = CreateObject("WScript.Shell").ExpandEnvironmentStrings("%APPDATA%") & "\7-PDFValidator\app.ini"

		Set fso = CreateObject("Scripting.FileSystemObject")
		sectionFound = False
		settingFound = False

		If fso.FileExists(iniPath) Then

			Set iniFile = fso.OpenTextFile(iniPath, 1) ' Read mode
			lines = Split(iniFile.ReadAll, vbCrLf)
			iniFile.Close

			newLines = ""

			For i = 0 To UBound(lines)
				line = Trim(lines(i))

				If line = "[7PDF_SETTINGS]" Then
					sectionFound = True
				End If

				If InStr(1, line, "PrivacyPolicyAggreed=", vbTextCompare) > 0 Then
					settingFound = True
					newLines = newLines & "PrivacyPolicyAggreed=YES" & vbCrLf
				Else
					newLines = newLines & line & vbCrLf
				End If
			Next

			If sectionFound And Not settingFound Then
				newLines = newLines & "PrivacyPolicyAggreed=YES" & vbCrLf
			End If

			If Not sectionFound Then
				newLines = newLines & vbCrLf & "[7PDF_SETTINGS]" & vbCrLf & "PrivacyPolicyAggreed=YES" & vbCrLf
			End If

			Set iniFile = fso.OpenTextFile(iniPath, 2) ' Write mode
			iniFile.Write newLines
			iniFile.Close
		Else
			MsgBox "Config file not found: " & iniPath, vbExclamation, "Error"
		End If

		Set iniFile = Nothing
		Set fso = Nothing
	End Sub

	Function IsValidatorInstalled()
		Dim fso
		Set fso = CreateObject("Scripting.FilesystemObject")
		IsValidatorInstalled = fso.FileExists("C:\Program Files (x86)\7-PDF\7-PDF E-Invoice Validator\SevenPDFValidator.exe")
		Set fso = Nothing
	End Function
	
	Function UserAgreesToValidation()
		Dim iniPath, fso, iniFile, line, found
		iniPath = CreateObject("WScript.Shell").ExpandEnvironmentStrings("%APPDATA%") & "\7-PDFValidator\app.ini"

		Set fso = CreateObject("Scripting.FilesystemObject")
		If fso.FileExists(iniPath) Then
			Set iniFile = fso.OpenTextFile(iniPath, 1)
			Do While Not iniFile.AtEndOfStream
				line = Trim(iniFile.ReadLine)
				If InStr(1, line, "PrivacyPolicyAggreed=YES", vbTextCompare) > 0 Then
					found = True
					Exit Do
				End If
			Loop
			iniFile.Close
			Set iniFile = Nothing
		End If
		Set fso = Nothing
		UserAgreesToValidation = found
	End Function
	
	Sub ValidateEInvoice(ByVal pdfFile)
		Dim objShell, exitCode, command
		
		Set objShell = CreateObject("WScript.Shell")
		command = """C:\Program Files (x86)\7-PDF\7-PDF E-Invoice Validator\SevenPDFValidator.exe"" -mode ""hidden"" -infile """ & pdfFile & """"
		exitCode = objShell.Run(command, 0, True)

		Select Case exitCode
			Case 0
				MsgBox "Well done!! The e-invoice is **valid**! All done.", vbInformation, "Validation successfull"
			Case 1
				MsgBox "The E-Invoice is **not valid**! Please check the XML.", vbCritical, "Validation Failed"
			Case 2
				MsgBox "An error occurred during validation, please set parameter -logfile ""[PATH]"" to lock the error messages by logfile and try again!", vbCritical, "Validation Error"
			Case 3
				MsgBox "License required! Please upgrade to the full version.", vbExclamation, "License Required"
				objShell.Run "https://www.7-pdf.com/products/pdf-e-invoice-validator/upgrade-to-full-version", 1, False
		End Select
		Set objShell = Nothing
	End Sub
	
	Function PromptToInstallValidator()
		PromptToInstallValidator = (MsgBox("7-PDF E-Invoice Validator is not installed." & vbCrLf & "Would you like to download and install it now? This can take a moment, please wait...", vbYesNo + vbQuestion, "Validator Missing") = vbYes)
	End Function
	
	Sub InstallValidator()
		Dim objShell, http, stream, downloadPath, fso, downloadsFolder, installerUrl

		Set objShell = CreateObject("WScript.Shell")
		downloadsFolder = objShell.ExpandEnvironmentStrings("%USERPROFILE%") & "\Downloads"
		downloadPath = downloadsFolder & "\7-PDF-E-Invoice-Validator.exe"
		installerUrl = "https://www.7-pdf.de/sites/default/files/downloads/7-pdf-e-invoice-validator/7-PDF-E-Invoice-Validator.exe"

		Set fso = CreateObject("Scripting.FileSystemObject")
		If Not fso.FolderExists(downloadsFolder) Then
			fso.CreateFolder downloadsFolder
		End If

		Set http = CreateObject("MSXML2.XMLHTTP")
		Set stream = CreateObject("ADODB.Stream")

		http.Open "GET", installerUrl, False
		http.Send

		If http.Status = 200 Then
			stream.Type = 1
			stream.Open
			stream.Write http.ResponseBody
			stream.SaveToFile downloadPath, 2
			stream.Close
			objShell.Run """" & downloadPath & """ /VERYSILENT", 0, True
			MsgBox "Installation completed! Please restart printing.", vbInformation, "Installation Done"
			restartPrinting = True
		Else
			MsgBox "Error downloading installation file. Please try again later.", vbCritical, "Error"
		End If

		Set http = Nothing
		Set stream = Nothing
		Set objShell = Nothing
	End Sub